(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs'), require('@angular/material'), require('@angular/common'), require('@angular/common/http'), require('@angular/core'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('@ngxlib/loading-bar', ['exports', 'rxjs', '@angular/material', '@angular/common', '@angular/common/http', '@angular/core', 'rxjs/operators'], factory) :
    (factory((global.ngxlib = global.ngxlib || {}, global.ngxlib['loading-bar'] = {}),global.rxjs,global.ng.material,global.ng.common,global.ng.common.http,global.ng.core,global.rxjs.operators));
}(this, (function (exports,rxjs,material,common,http,core,operators) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var LOADING_BAR_ITEMS = 'loading_bar_items';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var LoadingBarService = /** @class */ (function () {
        function LoadingBarService(items) {
            this.items = items;
            this.state = this.items.length !== 0;
            this.stateSubject = new rxjs.BehaviorSubject(this.state);
            this.isLoading = this.stateSubject.asObservable();
        }
        /**
         * @private
         * @return {?}
         */
        LoadingBarService.prototype.next = /**
         * @private
         * @return {?}
         */
            function () {
                if ((this.items.length !== 0) !== this.state) {
                    this.state = !this.state;
                    this.stateSubject.next(this.state);
                }
            };
        /**
         * @param {?} item
         * @return {?}
         */
        LoadingBarService.prototype.present = /**
         * @param {?} item
         * @return {?}
         */
            function (item) {
                var _this = this;
                /** @type {?} */
                var t = setTimeout(( /**
                 * @return {?}
                 */function () {
                    _this.items.push(item);
                    _this.next();
                    clearTimeout(t);
                }));
            };
        /**
         * @param {?} item
         * @return {?}
         */
        LoadingBarService.prototype.complete = /**
         * @param {?} item
         * @return {?}
         */
            function (item) {
                var _this = this;
                /** @type {?} */
                var t = setTimeout(( /**
                 * @return {?}
                 */function () {
                    /** @type {?} */
                    var index = _this.items.indexOf(item);
                    if (index !== -1) {
                        _this.items.splice(index, 1);
                        _this.next();
                    }
                    clearTimeout(t);
                }));
            };
        /**
         * @return {?}
         */
        LoadingBarService.prototype.dismissAll = /**
         * @return {?}
         */
            function () {
                var _this = this;
                /** @type {?} */
                var t = setTimeout(( /**
                 * @return {?}
                 */function () {
                    _this.items = [];
                    _this.next();
                    clearTimeout(t);
                }));
            };
        LoadingBarService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        LoadingBarService.ctorParameters = function () {
            return [
                { type: Array, decorators: [{ type: core.Inject, args: [LOADING_BAR_ITEMS,] }] }
            ];
        };
        return LoadingBarService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var LoadingBarComponent = /** @class */ (function () {
        function LoadingBarComponent(service) {
            this.service = service;
            this.mode = 'indeterminate';
            this.color = 'primary';
            this.position = 'fixed';
            this.top = 0;
            this.left = 0;
            this.right = 0;
            this.zIndex = 1001;
        }
        LoadingBarComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'mat-loading-bar',
                        template: "\n    <mat-progress-bar [mode]=\"mode\" [color]=\"color\" [value]=\"value\" *ngIf=\"service.isLoading|async\"></mat-progress-bar>"
                    }] }
        ];
        /** @nocollapse */
        LoadingBarComponent.ctorParameters = function () {
            return [
                { type: LoadingBarService }
            ];
        };
        LoadingBarComponent.propDecorators = {
            mode: [{ type: core.Input }],
            color: [{ type: core.Input }],
            value: [{ type: core.Input }],
            position: [{ type: core.HostBinding, args: ['style.position',] }, { type: core.Input }],
            top: [{ type: core.HostBinding, args: ['style.top',] }, { type: core.Input }],
            left: [{ type: core.HostBinding, args: ['style.left',] }, { type: core.Input }],
            right: [{ type: core.HostBinding, args: ['style.right',] }, { type: core.Input }],
            bottom: [{ type: core.HostBinding, args: ['style.bottom',] }, { type: core.Input }],
            zIndex: [{ type: core.HostBinding, args: ['style.z-index',] }, { type: core.Input }]
        };
        return LoadingBarComponent;
    }());

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var LoadingBarInterceptor = /** @class */ (function () {
        function LoadingBarInterceptor(service) {
            this.service = service;
        }
        /**
         * @param {?} req
         * @param {?} next
         * @return {?}
         */
        LoadingBarInterceptor.prototype.intercept = /**
         * @param {?} req
         * @param {?} next
         * @return {?}
         */
            function (req, next) {
                var _this = this;
                if (req.headers.has('skipLoadingBar')) {
                    return next.handle(req.clone({ headers: req.headers.delete('skipLoadingBar') }));
                }
                /** @type {?} */
                var r = next.handle(req);
                /** @type {?} */
                var started;
                /** @type {?} */
                var responseSubscribe = r.subscribe.bind(r);
                r.subscribe = ( /**
                 * @param {...?} args
                 * @return {?}
                 */function () {
                    var args = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        args[_i] = arguments[_i];
                    }
                    started = Math.random().toString(36).substring(7);
                    _this.service.present(started);
                    return responseSubscribe.apply(void 0, __spread(args));
                });
                return r.pipe(operators.finalize(( /**
                 * @return {?}
                 */function () { return !!started && _this.service.complete(started); })));
            };
        LoadingBarInterceptor.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        LoadingBarInterceptor.ctorParameters = function () {
            return [
                { type: LoadingBarService }
            ];
        };
        return LoadingBarInterceptor;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ɵ0 = [];
    var LoadingBarModule = /** @class */ (function () {
        function LoadingBarModule() {
        }
        LoadingBarModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [
                            LoadingBarComponent
                        ],
                        imports: [
                            common.CommonModule,
                            http.HttpClientModule,
                            material.MatProgressBarModule
                        ],
                        providers: [
                            { provide: LOADING_BAR_ITEMS, useValue: ɵ0 },
                            { provide: http.HTTP_INTERCEPTORS, useClass: LoadingBarInterceptor, multi: true },
                            LoadingBarService
                        ],
                        exports: [
                            LoadingBarComponent
                        ]
                    },] }
        ];
        return LoadingBarModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.LOADING_BAR_ITEMS = LOADING_BAR_ITEMS;
    exports.LoadingBarService = LoadingBarService;
    exports.LoadingBarComponent = LoadingBarComponent;
    exports.LoadingBarModule = LoadingBarModule;
    exports.ɵa = LoadingBarInterceptor;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ngxlib-loading-bar.umd.js.map