import { BehaviorSubject } from 'rxjs';
import { MatProgressBarModule } from '@angular/material';
import { CommonModule } from '@angular/common';
import { HTTP_INTERCEPTORS, HttpClientModule } from '@angular/common/http';
import { __spread } from 'tslib';
import { Inject, Injectable, Component, HostBinding, Input, NgModule } from '@angular/core';
import { finalize } from 'rxjs/operators';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var LOADING_BAR_ITEMS = 'loading_bar_items';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var LoadingBarService = /** @class */ (function () {
    function LoadingBarService(items) {
        this.items = items;
        this.state = this.items.length !== 0;
        this.stateSubject = new BehaviorSubject(this.state);
        this.isLoading = this.stateSubject.asObservable();
    }
    /**
     * @private
     * @return {?}
     */
    LoadingBarService.prototype.next = /**
     * @private
     * @return {?}
     */
    function () {
        if ((this.items.length !== 0) !== this.state) {
            this.state = !this.state;
            this.stateSubject.next(this.state);
        }
    };
    /**
     * @param {?} item
     * @return {?}
     */
    LoadingBarService.prototype.present = /**
     * @param {?} item
     * @return {?}
     */
    function (item) {
        var _this = this;
        /** @type {?} */
        var t = setTimeout((/**
         * @return {?}
         */
        function () {
            _this.items.push(item);
            _this.next();
            clearTimeout(t);
        }));
    };
    /**
     * @param {?} item
     * @return {?}
     */
    LoadingBarService.prototype.complete = /**
     * @param {?} item
     * @return {?}
     */
    function (item) {
        var _this = this;
        /** @type {?} */
        var t = setTimeout((/**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var index = _this.items.indexOf(item);
            if (index !== -1) {
                _this.items.splice(index, 1);
                _this.next();
            }
            clearTimeout(t);
        }));
    };
    /**
     * @return {?}
     */
    LoadingBarService.prototype.dismissAll = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var t = setTimeout((/**
         * @return {?}
         */
        function () {
            _this.items = [];
            _this.next();
            clearTimeout(t);
        }));
    };
    LoadingBarService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    LoadingBarService.ctorParameters = function () { return [
        { type: Array, decorators: [{ type: Inject, args: [LOADING_BAR_ITEMS,] }] }
    ]; };
    return LoadingBarService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var LoadingBarComponent = /** @class */ (function () {
    function LoadingBarComponent(service) {
        this.service = service;
        this.mode = 'indeterminate';
        this.color = 'primary';
        this.position = 'fixed';
        this.top = 0;
        this.left = 0;
        this.right = 0;
        this.zIndex = 1001;
    }
    LoadingBarComponent.decorators = [
        { type: Component, args: [{
                    selector: 'mat-loading-bar',
                    template: "\n    <mat-progress-bar [mode]=\"mode\" [color]=\"color\" [value]=\"value\" *ngIf=\"service.isLoading|async\"></mat-progress-bar>"
                }] }
    ];
    /** @nocollapse */
    LoadingBarComponent.ctorParameters = function () { return [
        { type: LoadingBarService }
    ]; };
    LoadingBarComponent.propDecorators = {
        mode: [{ type: Input }],
        color: [{ type: Input }],
        value: [{ type: Input }],
        position: [{ type: HostBinding, args: ['style.position',] }, { type: Input }],
        top: [{ type: HostBinding, args: ['style.top',] }, { type: Input }],
        left: [{ type: HostBinding, args: ['style.left',] }, { type: Input }],
        right: [{ type: HostBinding, args: ['style.right',] }, { type: Input }],
        bottom: [{ type: HostBinding, args: ['style.bottom',] }, { type: Input }],
        zIndex: [{ type: HostBinding, args: ['style.z-index',] }, { type: Input }]
    };
    return LoadingBarComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var LoadingBarInterceptor = /** @class */ (function () {
    function LoadingBarInterceptor(service) {
        this.service = service;
    }
    /**
     * @param {?} req
     * @param {?} next
     * @return {?}
     */
    LoadingBarInterceptor.prototype.intercept = /**
     * @param {?} req
     * @param {?} next
     * @return {?}
     */
    function (req, next) {
        var _this = this;
        if (req.headers.has('skipLoadingBar')) {
            return next.handle(req.clone({ headers: req.headers.delete('skipLoadingBar') }));
        }
        /** @type {?} */
        var r = next.handle(req);
        /** @type {?} */
        var started;
        /** @type {?} */
        var responseSubscribe = r.subscribe.bind(r);
        r.subscribe = (/**
         * @param {...?} args
         * @return {?}
         */
        function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            started = Math.random().toString(36).substring(7);
            _this.service.present(started);
            return responseSubscribe.apply(void 0, __spread(args));
        });
        return r.pipe(finalize((/**
         * @return {?}
         */
        function () { return !!started && _this.service.complete(started); })));
    };
    LoadingBarInterceptor.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    LoadingBarInterceptor.ctorParameters = function () { return [
        { type: LoadingBarService }
    ]; };
    return LoadingBarInterceptor;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ɵ0 = [];
var LoadingBarModule = /** @class */ (function () {
    function LoadingBarModule() {
    }
    LoadingBarModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [
                        LoadingBarComponent
                    ],
                    imports: [
                        CommonModule,
                        HttpClientModule,
                        MatProgressBarModule
                    ],
                    providers: [
                        { provide: LOADING_BAR_ITEMS, useValue: ɵ0 },
                        { provide: HTTP_INTERCEPTORS, useClass: LoadingBarInterceptor, multi: true },
                        LoadingBarService
                    ],
                    exports: [
                        LoadingBarComponent
                    ]
                },] }
    ];
    return LoadingBarModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { LOADING_BAR_ITEMS, LoadingBarService, LoadingBarComponent, LoadingBarModule, LoadingBarInterceptor as ɵa };

//# sourceMappingURL=ngxlib-loading-bar.js.map